LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;

LIBRARY work;
USE work.YOLO_pkg.ALL;

ENTITY L2_BNROM IS
    PORT (
        clk : IN STD_LOGIC;
        coefs : OUT STD_LOGIC_VECTOR(63 DOWNTO 0); -- Instruction bus
        address : IN unsigned(3 DOWNTO 0));
END L2_BNROM;

ARCHITECTURE RTL OF L2_BNROM IS

    TYPE ROM_mem IS ARRAY (0 TO 15) OF STD_LOGIC_VECTOR(63 DOWNTO 0);

    --kernel2(bias&scale) & kernel1(bias&scale)

    signal ROM_content : ROM_mem :=
    (0=>"0000000110101011"&"0000000101110001"&"0000001110011011"&"0000000111010111",
    1=>"0000000111000100"&"0000001000111100"&"1111110110001100"&"0000000101111010",
    2=>"0000011000000101"&"0000000101000111"&"0000010011001101"&"0000000011010001",
    3=>"0000000100100011"&"0000000110001000"&"0000000100100001"&"0000001000111100",
    4=>"0000001010101001"&"0000000101101010"&"0000000011101011"&"0000000111010101",
    5=>"0000000010110011"&"0000000100001011"&"0000000100010011"&"0000001000101111",
    6=>"0000010001010110"&"0000000110100001"&"0000000001110011"&"0000000011110000",
    7=>"0000001000100001"&"0000000110000000"&"0000011111111101"&"0000000100101010",
    8=>"0000001000101010"&"0000000100101111"&"0000010010111010"&"0000000011101110",
    9=>"0000000110101010"&"0000001000100011"&"1111111111010010"&"0000000110100110",
    10=>"0000001000011110"&"0000000111001010"&"0000001100101111"&"0000000100010110",
    11=>"0000010010111101"&"0000000110111111"&"0000000110111011"&"0000000111001010",
    12=>"0000000111111100"&"0000001000000000"&"1111111111100001"&"0000000011000101",
    13=>"0000001001100110"&"0000000101101011"&"1111110000100100"&"0000000001111111",
    14=>"0000001111011101"&"0000000101101000"&"0000000111001101"&"0000001000000001",
    15=>"1111111100000011"&"0000000111000001"&"0000010000101111"&"0000000110010010");

    attribute rom_style : string; 
    attribute rom_style of ROM_content : signal is "block";
BEGIN
proc_name : PROCESS (clk)
BEGIN
  IF rising_edge(clk) THEN
    coefs <= ROM_content(to_integer(address));
  END IF;
END PROCESS proc_name;END RTL;